#include "defines.h"

extern short bool_shipview;

extern GLfloat shipdb[32][9];
extern short selected_ship;

extern short orbit_xang_bool;
extern short orbit_yang_bool;
extern short orbit_zang_bool;
extern short orbit_zoom_bool;
extern GLfloat orbit_xang;
extern GLfloat orbit_yang;
extern GLfloat orbit_zoom;

extern GLfloat gradual_x;
extern GLfloat gradual_y;
extern GLfloat gradual_z;
extern GLfloat gradual_center_x;
extern GLfloat gradual_center_y;
extern GLfloat gradual_center_z;
extern GLfloat follow_zoom;

extern double fps;

void camerasmooth(void)
{
	GLfloat tempx, tempy, tempz;

	// If we are orbiting
	if(selected_ship == -1)
	{
		// Assign the eventual values to temp? first
                tempx=sin(PI*orbit_xang/180)*cos(PI*orbit_yang/180)*orbit_zoom;
                tempy=sin(PI*orbit_yang/180)*orbit_zoom;
                tempz=cos(PI*orbit_xang/180)*cos(PI*orbit_yang/180)*orbit_zoom;

		// This makes it smooth transition between 't''ing
		gradual_x += (tempx-gradual_x)/(TRANSITION_FACTOR*fps);
		gradual_y += (tempy-gradual_y)/(TRANSITION_FACTOR*fps);
		gradual_z += (tempz-gradual_z)/(TRANSITION_FACTOR*fps);

		// Makes the center point gradual too...biotch!
		gradual_center_x += (-gradual_center_x)/(TRANSITION_FACTOR*fps);
		gradual_center_y += (-gradual_center_y)/(TRANSITION_FACTOR*fps);
		gradual_center_z += (-gradual_center_z)/(TRANSITION_FACTOR*fps);

		gluLookAt(gradual_x, gradual_y, gradual_z,
				gradual_center_x, gradual_center_y, gradual_center_z,
				0.0, 1.0, 0.0);

	}
	// If we are looking at a ship
	else
	{
		// If we're following it from the back (default)
		if(bool_shipview == -1)
		{
			// Assign the eventual values to temp? first
			tempx = shipdb[selected_ship][0]-
				sin(PI*((int)(shipdb[selected_ship][4]+90)%360)/180)*
				(follow_zoom);
			tempy = shipdb[selected_ship][1]+
				(follow_zoom/2.0);
			tempz = shipdb[selected_ship][2]+
				cos(PI*((int)(shipdb[selected_ship][4]+90)%360)/180)*
				(follow_zoom);

			// Then make the smooth (it'll neveer get there)
			// transition between the initial value of gradual_?
			// to temp?
			gradual_x += (tempx-gradual_x)/(TRANSITION_FACTOR*fps);
			gradual_y += (tempy-gradual_y)/(TRANSITION_FACTOR*fps);
			gradual_z += (tempz-gradual_z)/(TRANSITION_FACTOR*fps);

			// Makes the center point gradual too...biotch!
			gradual_center_x += (shipdb[selected_ship][0]-gradual_center_x)/(TRANSITION_FACTOR*fps);
			gradual_center_y += (shipdb[selected_ship][1]-gradual_center_y)/(TRANSITION_FACTOR*fps);
			gradual_center_z += (shipdb[selected_ship][2]-gradual_center_z)/(TRANSITION_FACTOR*fps);

			gluLookAt(gradual_x, gradual_y, gradual_z,
					gradual_center_x, gradual_center_y, gradual_center_z,
					0.0, 1.0, 0.0);
		}
		// Gee, guess we're looking at it from 0,0,0, really nifty!
		else
		{
			// This makes it smooth transition between 't''ing
			gradual_x += (-gradual_x)/(TRANSITION_FACTOR*fps);
			gradual_y += (-gradual_y)/(TRANSITION_FACTOR*fps);
			gradual_z += (-gradual_z)/(TRANSITION_FACTOR*fps);

			// Makes the center point gradual too...biotch!
			gradual_center_x += (shipdb[selected_ship][0]-gradual_center_x)/(TRANSITION_FACTOR*fps);
			gradual_center_y += (shipdb[selected_ship][1]-gradual_center_y)/(TRANSITION_FACTOR*fps);
			gradual_center_z += (shipdb[selected_ship][2]-gradual_center_z)/(TRANSITION_FACTOR*fps);

			gluLookAt(gradual_x, gradual_y, gradual_z,
					gradual_center_x,
					gradual_center_y,
					gradual_center_z,
					0.0, 1.0, 0.0);
		}
	}

}
