#include "defines.h"

extern GLUquadricObj* gluObj;

// Creates a tie-fighter...the cheap ones you blow up easily...heh
void tiefighter(float g)
{
	// Set the material
	setMaterials(&gengrey, GL_FRONT_AND_BACK);

	// Make the pilot thingy
	gluSphere(gluObj, 0.05/g, 16, 16);

	// Make the pylons
	glPushMatrix();
		glTranslatef(-0.04/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.01/g, 0.08/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.04/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.01/g, 0.08/g, 8, 8);
	glPopMatrix();

	// Make the smooth thingy on the outside of solar panels
	glPushMatrix();
		glTranslatef(0.11/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.03/g, 0.01/g, 0.01/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.11/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.03/g, 0.01/g, 0.01/g, 8, 8);
	glPopMatrix();

	// Make the smooth thingy on the inside of solar panels
	glPushMatrix();
		glTranslatef(0.09/g, 0.0, 0.0);
		glRotatef(90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.03/g, 0.01/g, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(-0.09/g, 0.0, 0.0);
		glRotatef(-90, 0.0, 1.0, 0.0);
		gluCylinder(gluObj, 0.01/g, 0.03/g, 0.01/g, 8, 8);
	glPopMatrix();

	// Make the solar panels
	setMaterials(&bluesolarpanels, GL_FRONT_AND_BACK);
	tdrect(0.1/g, 0.1/g, 0.1/g, 0.11/g, -0.1/g, -0.1/g);	// Left
	tdrect(-0.1/g, 0.1/g, 0.1/g, -0.11/g, -0.1/g, -0.1/g);	// Right

	// Make the laser thingies on the pilot module
	glPushMatrix();
		glTranslatef(0.0, 0.0, 0.05/g);
		glRotatef(45, 1.0, 0.0, 0.0);
		setMaterials(&redlaser, GL_FRONT_AND_BACK);
		gluSphere(gluObj, 0.005/g, 4, 4);
		setMaterials(&gengrey, GL_FRONT_AND_BACK);
	glPopMatrix();
}

// Creates some kind of spaceship assuming -1.0, 1.0 ortho {x,y,z}
void stardestroyer(float s)
{
	// Create the top triangular planes
	glBegin(GL_TRIANGLES);
		glNormal3f(0.2, 0.8, 0.0);
		glVertex3f(-0.125/s, 0.0, -0.25/s);	// Left
		glVertex3f(0.0, 0.0375/s, -0.25/s);	// Back
		glVertex3f(0.0, 0.0, 0.25/s);	// Front
	glEnd();
	
	glBegin(GL_TRIANGLES);
		glNormal3f(-0.2, 0.8, 0.0);
		glVertex3f(0.0, 0.0375/s, -0.25/s);	// Back
		glVertex3f(0.125/s, 0.0, -0.25/s);	// Right
		glVertex3f(0.0, 0.0, 0.25/s);	// Front
	glEnd();

	// Create the thickness (essentially) for the left
	glBegin(GL_QUADS);
		glNormal3f(-1.0, 0.0, 0.0);
		glVertex3f(0.0, 0.0, 0.25/s);
		glVertex3f(-0.125/s, 0.0, -0.25/s);
		glVertex3f(-0.125/s, -0.02/s, -0.25/s);
		glVertex3f(0.0, -0.02/s, 0.25/s);
	glEnd();

	// Create the thickness (essentially) for the right
	glBegin(GL_QUADS);
		glNormal3f(1.0, 0.0, 0.0);
		glVertex3f(0.0, 0.0, 0.25/s);
		glVertex3f(0.125/s, 0.0, -0.25/s);
		glVertex3f(0.125/s, -0.02/s, -0.25/s);
		glVertex3f(0.0, -0.02/s, 0.25/s);
	glEnd();

	// Create the bottom triangular planes
	glBegin(GL_TRIANGLES);
		glNormal3f(0.2, -0.8, 0.0);
		glVertex3f(-0.125/s, -0.02/s, -0.25/s);	// Left
		glVertex3f(0.0, -0.02/s, 0.25/s);	// Front
		glVertex3f(0.0, -0.0575/s, -0.25/s);	// Back
	glEnd();
	
	glBegin(GL_TRIANGLES);
		glNormal3f(-0.2, -0.8, 0.0);
		glVertex3f(0.125/s, -0.02/s, -0.25/s);	// Right
		glVertex3f(0.0, -0.0575/s, -0.25/s);	// Back
		glVertex3f(0.0, -0.02/s, 0.25/s);	// Front
	glEnd();

	// Create the bridge thingy
	tdrect(-0.07/s, 0.125/s, -0.175/s, 0.07/s, 0.17/s, -0.225/s);

	// Make the thing connecting the bridge to the ship
	tdrect(-0.02/s, 0.0, -0.1755/s, 0.02/s, 0.1255/s, -0.2245/s);

	// Make the shield generators
	glPushMatrix();
		glTranslatef(-0.045/s, 0.19/s, -0.2/s);
		gluSphere(gluObj, 0.02/s, 16, 16);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.045/s, 0.19/s, -0.2/s);
		gluSphere(gluObj, 0.02/s, 16, 16);
	glPopMatrix();

	// Make the back plate of the ship (where engines go)
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 0.0, -1.0);
		glVertex3f(0.125/s, 0.0/s, -0.24/s);
		glVertex3f(0.0, 0.0375/s, -0.24/s);
		glVertex3f(-0.125/s, 0.0, -0.24/s);
		glVertex3f(-0.125/s, -0.02/s, -0.24/s);
		glVertex3f(0.0, -0.0575/s, -0.24/s);
		glVertex3f(0.125/s, -0.02/s, -0.24/s);
	glEnd();

	// Make the engines
	glPushMatrix();
		glTranslatef(-0.07/s, -0.01/s, -0.26/s);
		gluCylinder(gluObj, 0.02/s, 0.01/s, 0.02/s, 16, 16);
	glPopMatrix();

		glPushMatrix();
		glTranslatef(0.0, -0.01/s, -0.26/s);
		gluCylinder(gluObj, 0.02/s, 0.01/s, 0.02/s, 16, 16);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.07/s, -0.01/s, -0.26/s);
		gluCylinder(gluObj, 0.02/s, 0.01/s, 0.02/s, 16, 16);
	glPopMatrix();
	
	// Make the blue stuff in the engines
	setMaterials(&bluengines, GL_FRONT_AND_BACK);

	glPushMatrix();
		glTranslatef(-0.07/s, -0.01/s, -0.252/s);
		gluSphere(gluObj, 0.014/s, 8, 8);
	glPopMatrix();
	
	glPushMatrix();
		glTranslatef(0.0, -0.01/s, -0.252/s);
		gluSphere(gluObj, 0.014/s, 8, 8);
	glPopMatrix();

	glPushMatrix();
		glTranslatef(0.07/s, -0.01/s, -0.252/s);
		gluSphere(gluObj, 0.014/s, 8, 8);
	glPopMatrix();
}

// Generic 3D Rectangle
// starting coords, ending coords, color
void tdrect(GLfloat x1, GLfloat y1, GLfloat z1, GLfloat x2, GLfloat y2, GLfloat z2)
{
	// Back face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(x1, y1, z2);
		glVertex3f(x1, y2, z2);
		glVertex3f(x2, y2, z2);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Left face
	glBegin(GL_POLYGON);
		glNormal3f(-1.0, 0.0, 0.0);
		glVertex3f(x1, y1, z1);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y2, z2);
		glVertex3f(x1, y1, z2);
	glEnd();

	// Top face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 1.0, 0.0);
		glVertex3f(x1, y2, z2);
		glVertex3f(x1, y2, z1);
		glVertex3f(x2, y2, z1);
		glVertex3f(x2, y2, z2);
	glEnd();

	// Right face
	glBegin(GL_POLYGON);
		glNormal3f(1.0, 0.0, 0.0);
		glVertex3f(x2, y2, z1);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y1, z2);
		glVertex3f(x2, y2, z2);
	glEnd();

	// Bottom face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, -1.0, 0.0);
		glVertex3f(x2, y1, z1);
		glVertex3f(x1, y1, z1);
		glVertex3f(x1, y1, z2);
		glVertex3f(x2, y1, z2);
	glEnd();

	// Front face
	glBegin(GL_POLYGON);
		glNormal3f(0.0, 0.0, -1.0);
		glVertex3f(x1, y2, z1);
		glVertex3f(x1, y1, z1);
		glVertex3f(x2, y1, z1);
		glVertex3f(x2, y2, z1);
	glEnd();
}
